/*******************************************************************************
    riv2ascii
    Copyright (C) 2003  Harm Schotanus

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*******************************************************************************/

#include <iostream>
#include <string>
#include "riv2ascii.h"
#include "r2a_helper.h"
#include "riv_error.h"
#include "r2a_country.h"
#include "r2a_html.h"
#include "r2a_prog_error.h"


using std::endl;


country_code::country_code() : code (UIC), min_year (0), max_year (0)
{
}


country_code::country_code(
  const unsigned  c,
  const string& cnt,
  const string& abbr,
	const string& comp,
  const unsigned min_y,
  const unsigned max_y
) : country(cnt), company(comp), abbrev(abbr)
{
	if (min_y > max_y  && max_y != 0) throw ill_value(ill_value::YEAR, min_y);
  if (c > 99 ) throw ill_value(ill_value::COUNTRY, c);
	code = c;
	min_year = min_y;
	max_year = max_y;
}


void
print (
  ostream& out,
  const country_code& c,
  const bool html
)
{
  put_row_column(out, html);
	out << c.get_code();
  put_column(out, html, ": ");
	out	<< c.get_abbrev() << ' ';
  put_column(out, html);
	out	<< c.get_country() << ' ';
  put_column(out, html);
	print_range(out, c.get_min_year(), c.get_max_year());
  put_column(out, html);
	out	<< c.get_company() << endl;
}

