/***************************************************************************
                          r2a_country.h  -  description
                             -------------------
    begin                : Fri Apr 30 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_COUNTRY_H
#define R2A_COUNTRY_H

#include <string>
#include <iostream>
#include "riv2ascii.h"


using std::string ;
using std::ostream;


class country_code {
private:
	unsigned code, min_year, max_year;
	string country;	
	string company;
	string abbrev;

public:
	country_code ();
  ~country_code ()  throw() {}
	country_code (
    const unsigned c,
    const string& country,
    const string& abbrev,
    const string& company,
  	const unsigned min_y=0,
    const unsigned max_y=0
  );
	unsigned get_code () const;
	unsigned get_min_year () const;
	unsigned get_max_year () const;
	const string& get_country () const;
	const string& get_company () const;
  const string& get_abbrev () const;
  bool match (const unsigned cd) const;
};


void print (
    ostream& out,
    const country_code& x,
    const bool html=false
) ;


inline unsigned
country_code::get_code() const
{
  return code;
}


inline unsigned
country_code::get_min_year() const
{
  return min_year;
}


inline unsigned
country_code::get_max_year() const
{
  return max_year;
}


inline const string&
country_code::get_country() const
{
  return country;
}


inline const string&
country_code::get_company() const
{
  return company;
}


inline const string&
country_code::get_abbrev() const
{
  return abbrev;
}


inline ostream&
operator<< (
  ostream& out,
  const country_code& c
)
{
  print(out, c);
  return out;
}


inline bool
country_code::match (
  const unsigned cd
) const
{
  return cd == get_code();
}


#endif /* __R2A_COUNTRY__ */

