/***************************************************************************
                          r2a_country_list.h  -  description
                             -------------------
    begin                : Sun Jun 6 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_COUNTRY_LIST_H
#define R2A_COUNTRY_LIST_H

#include <string>
#include <iostream>
#include <list>
#include "riv2ascii.h"
#include "r2a_country.h"
#include "r2a_handle.h"


using std::string;
using std::list;


class country_code_list {
private:
  typedef list < handleT <country_code> > country_code_listT;
  typedef country_code_listT::iterator country_code_iter;
  typedef country_code_listT::const_iterator country_code_citer;

  country_code_listT c_list;

public:
  country_code_list() throw() {}
  ~country_code_list() throw();
  void clear() throw();
  void print (ostream& out, const bool html=false) const;
  string find_company (const unsigned cd) const;
  string find_country (const unsigned cd) const;
  unsigned find_country (const string& cmp) const;
  handleT <country_code> find(const unsigned cd) const;
  handleT <country_code> find(const string& cmp) const;
  void add (const handleT <country_code>& c);
};


inline
country_code_list::~country_code_list()  throw()
{
}


inline ostream&
operator<< (
  ostream& out,
  const country_code_list& c
)
{
  c.print(out);
  return out;
}


inline string
country_code_list::find_country (
  const unsigned cd
) const
{
	return find(cd)->get_abbrev();
}


inline string
country_code_list::find_company (
  const unsigned cd
) const
{
	return find(cd)->get_company();
}


inline unsigned
country_code_list::find_country (
  const string& cmp
) const
{
  return find(cmp)->get_code();
}


inline void
country_code_list::clear() throw()
{
  c_list.clear();
}


#endif

