/***************************************************************************
                          r2a_handle.h  -  description
                             -------------------
    begin                : Sun Aug 1 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_HANDLE_H
#define R2A_HANDLE_H


class bad_ptr {
public:
  bad_ptr(int =0) {}
};


template <class X>
class handleT {
private:
  X* val;
  unsigned* count;
//  handleT(X* ptr, unsigned cnt) : val(ptr), count (cnr) { }
public:
 ~handleT();
  handleT(const handleT& ptr);
  explicit handleT(X* ptr);
  X* operator ->() ;
  X* get_ptr() const ;
  unsigned get_count() const;
  X& operator* () ;
  const X* operator ->() const;
  const X& operator* () const;

//  template <class Y> operator handleT<Y> () {return handleT<Y>(val, count + 1);}
  handleT& operator= (const handleT& ptr);
  handleT& operator= (X* ptr);
  bool operator==(const handleT& ptr) const;
  bool operator< (const handleT& ptr) const;
  bool operator==(const X* ptr) const;
  bool operator< (const X* ptr) const;
};


template <class X>
inline handleT<X>::handleT(X* ptr)
{
  if (ptr == 0) throw bad_ptr(0);
  count = new unsigned (1);
  val = ptr;
}


template <class X>
inline bool
handleT<X>::operator==(const handleT<X>& ptr) const
{
  return val == ptr.val;
}


template <class X>
inline bool
handleT<X>::operator< (const handleT<X>& ptr) const
{
  return val < ptr.val;
}


template <class X>
inline bool
handleT<X>::operator==(const X* ptr) const
{
  return val == ptr;
}


template <class X>
inline bool
handleT<X>::operator< (const X* ptr) const
{
  return val < ptr;
}


template <class X>
inline handleT<X>&
handleT<X>::operator= (const handleT<X>& ptr)
{
  if (val == ptr.val) return *this;
  if (--(*count) == 0) {
    delete val;
    delete count;
  }
  val = ptr.val;
  count = ptr.count;
  ++(*count);
  return *this;
}


template <class X>
inline handleT<X>&
handleT<X>::operator= (X* ptr)
{
  if (ptr == NULL) throw bad_ptr(0);
  if (val == ptr) return *this;
  if (--(*count) == 0) {
    delete val;
    delete count;
  }
  val = ptr;
  count = new unsigned (1);
  return *this;
}


template <class X>
inline
handleT<X>::~handleT()
{
  if (--(*count) == 0) {
    delete val;
    delete count;
  }
}


template <class X>
inline X*
handleT<X>::operator ->()
{
  return val;
}


template <class X>
inline X*
handleT<X>::get_ptr() const
{
  return val;
}


template <class X>
inline unsigned
handleT<X>::get_count() const
{
  return *count;
}


template <class X>
inline X&
handleT<X>:: operator* ()
{
  return *val;
}


template <class X>
inline const X*
handleT<X>:: operator ->() const
{
  return val;
}


template <class X>
inline const X&
handleT<X>::operator* () const
{
  return *val;
}


template <class X>
inline
handleT<X>::handleT(const handleT& ptr) : val (ptr.val), count (ptr.count)
{
  ++(*count);
}


#endif

