/***************************************************************************
                          r2a_html.h  -  description
                             -------------------
    begin                : Sun Jul 18 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef R2A_HTML_H
#define R2A_HTML_H


#include <iostream>
#include <string>


using std::endl;
using std::string;
using std::ostream;


class put_html {
private:
  ostream& out;
  bool html;
protected:
  put_html(ostream& o, const bool h) : out (o), html(h) {}
  bool get_html() { return html;}
  ostream& get_out() { return out;}
public:
  ~put_html() {}
};


class put_table: public put_html {
public:
  put_table(ostream& o, const bool h) : put_html(o, h)
  {
    if (get_html()) get_out() << "<table>" << endl;
  }
  ~put_table()
  {
    if (get_html()) get_out() << "</table>" << endl;
  }
};


class put_head: public put_html {

public:
  put_head(
    ostream& o,
    const bool h,
    const string& title="",
    const string& text=""
    ) : put_html (o, h)
  {
    if (get_html()) get_out() << "<html>\n<head>\n<title>" << title <<  text << "</title>\n</head>\n<body>" << endl;
  }
  ~put_head()
  {
    if (get_html()) get_out() << "</body>\n</html>" << endl << endl;
  }
};


inline void
put_row (ostream& out, const bool html, const string& alternate="")
{
  out << (html ? "<tr>" : alternate);
}


inline void
put_column (ostream& out, const bool html, const string& alternate="")
{
  out << (html ? "<td>" : alternate);
}


inline void
put_row_column (ostream& out, const bool html, const string& alternate="")
{
  out << (html ? "<tr><td>" : alternate);
}


inline void
put_line (ostream& out, const bool html, const string& alternate="")
{
  out << (html ? "<br>" : alternate);
}
		

#endif

