/***************************************************************************
                          r2a_iga.h  -  description
                             -------------------
    begin                : Sun Jul 4 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_IGA_H
#define R2A_IGA_H


#include <string>
#include <iostream>
#include "riv2ascii.h"
#include "riv_error.h"


using std::string;
using std::ostream;


/**
  *@author Harm Anne Schotanus
  */

/*
  Lbenr	 Lngde	Beskrivelse
Runningnr	 Length	Description
Laufnr	 Lnge	Beschreibung

  1		  1		Frste bogstav af <10>
				(First letter of <10>/Erster Buchstabe der <10>)
  2 -   9	  7 +1	<13>	Laveste nr   (ERSTER WAGENNR/FIRST WAGGON NR)
 10 -  21	 12		<10>	UICLTR           (UIC SOLL-GATTUNG/UIC CODE)
 22 -  27	  6		<12>	REGIME  [21_77_] (AUSTAUCHCODE/REGIME CODE)
 28 -  35	  7 +1	<48>	BANE           (BAHNGESELLSCHAFT/RAILWAY COMPANY)
 36 -  43	  8		<14>	Hjeste nr (LETZTER WAGENNUMMER/LAST WAGGON NR)
 44 -  55	 12		<15>	LITRA    (GATTUNG/CODE)
 56 -  65	 10		<16>	TYPE     (WAGENTYP/WAGGONTYPE)
 66 -  73	  8		<17>	Laveste EX-NR (EX-NUMMER/FORMER NR)
 74 -  81	  8		<18>	Hjeste EX-NR
 82 -  93	 12		<19>	EX-LITRA (EX-GATTUNG/FORMER CODE)
 94 - 101	  6 +2	<45>	ANTAL    (WAGENBESTAND/NUMBERS)
102 - 142	 40 +1	<50>	BEMRKNINGER  (BEMERKUNGEN/REMARKS)
143 - 147	  5		<20>	LOP MIN
148 - 152	  5		<21>	LOP MAX  (LP/LENGTH OVER BUFFERS)
153 - 157	  5		<22>	AXT/BCA  (ACHSSTAND/AXLE WIDTH)
158 - 161	  4		<23>	BOGIEAXT (ACHSSTAND DREHGEST/AXLE WIDTH BOGIE)
162 - 166	  5		<24>	INDVLGD  (LADELNGE/FLOOR LENGTH)
167 - 170	  4		<25>	INDVBRD  (LADEBREITE/FLOOR WIDTH)
171 - 174	  4		<26>	BUNDFL   (LADEFLCHE/FLOOR SIZE)
175 - 178	  4		<27>	IHJDSIDE (LADEHHE SEITE/HEIGTH INSIDE SIDE)
179 - 182	  4		<28>	IHJDMIDT (LADEHHE MITTE/HEIGTH INSIDE CENTER)
183 - 187	  5		<29>	RUMFANG  (LADERAUM/VOLUME)
188 - 192	  5		<30>	DBR/SSH  (TRBREITE/WIDTH OF DOOR)
193 - 196	  4		<31>	DHJ/ESH  (TRHHE/HIGHTH OF DOOR)
197 - 200	  4		<32>	GULVHJD  (BODENHHE/FLOOR HIGHTH)
201 - 205	  5		<34>	TARAVGT (EIGENGEWICHT/TARE)
206 - 211	  5 +1	<35>	MAX LAST (LADUNG/LOAD)
212 - 215	  4		<36>	V/KMH
216 - 219	  4		<37>	MAX KMH
220 - 223	  4		<38>	V/LAST
224 - 225	  2		<39>	120/00t
226 - 229	  4		<40>	BR AUT
230 - 233	  4		<41>	BR MAN
234 - 243	 10		<11>	UIC TYPE
244 - 249	  5 +1	<43>	BYGGER (BAUJAHR/YEAR BUILT)
250 - 252	  2 +1	<44>	TILGANG (ZUGANG/FIRST YEAR OF USE)
253 - 254	  2		<46>	SIDST SET (ZULETZT GESEHEN/LAST YEAR SPOTTED)
255 - 256	  2		0D 0A   CR+LF
*/

class iga {
  char letter;
  unsigned first_nr;
  string uic_code;
  string regime_code;
  unsigned regime;
  unsigned country_code;
  string railway_company;
  unsigned last_nr;
  string code;
  string type;
  unsigned first_former_nr;
  unsigned last_former_nr;
  string former_code;
  unsigned numbers;
  string remarks;
  unsigned min_buffer_length;
  unsigned max_buffer_length;
  unsigned axle_width;
  unsigned axle_width_bogey;
  unsigned floor_length;
  unsigned floor_width;
  unsigned floor_size;
  unsigned height_inside_side;
  unsigned height_inside_center;
  unsigned volume;
  unsigned door_width;
  unsigned door_height;
  unsigned floor_height;
  unsigned tare;
  unsigned max_load;
  unsigned speed;
  unsigned max_distance;
  unsigned v_last;
  string br_aut;
  string br_man;
  string UIC_type;
  unsigned year_built;
  unsigned first_use;
  unsigned last_spotted;
public: 
	iga();
	~iga();
  iga (const string& uic_code);
  char get_letter() const { return letter;}
  unsigned get_first_nr() const { return first_nr;}
  const string& get_uic_code() const { return uic_code;}
  const string& get_regime_code() const { return regime_code;}
  unsigned get_regime() const  { return regime;}
  unsigned get_country_code () const { return country_code;}
  const string& get_railway_company() const { return railway_company;}
  unsigned get_last_nr() const { return last_nr;}
  const string& get_code() const { return code;}
  const string& get_type() const { return type;}
  unsigned get_first_former_nr() const { return first_former_nr;}
  unsigned get_last_former_nr() const { return last_former_nr;}
  const string& get_former_code() const { return former_code;}
  unsigned get_numbers() const { return numbers;}
  const string& get_remarks() const { return remarks;}
  unsigned get_min_buffer_length() const { return min_buffer_length;}
  unsigned get_max_buffer_length() const { return max_buffer_length;}
  unsigned get_axle_width() const { return axle_width;}
  unsigned get_axle_width_bogey() const { return axle_width_bogey ;}
  unsigned get_floor_length() const { return floor_length;}
  unsigned get_floor_width() const { return floor_width;}
  unsigned get_floor_size() const { return floor_size;}
  unsigned get_height_inside_side() const { return height_inside_side;}
  unsigned get_height_inside_center() const { return height_inside_center;}
  unsigned get_volume() const { return volume;}
  unsigned get_door_width() const { return door_width;}
  unsigned get_door_height() const { return door_height;}
  unsigned get_floor_height() const { return floor_height;}
  unsigned get_tare() const { return tare;}
  unsigned get_max_load() const { return max_load;}
  unsigned get_speed() const { return speed;}
  unsigned get_max_distance() const { return max_distance ;}
  unsigned get_v_last() const { return v_last;}
  string get_br_aut() const { return br_aut;}
  string get_br_man() const { return br_man;}
  string get_UIC_type() const { return UIC_type;}
  unsigned get_year_built() const { return year_built;}
  unsigned get_first_use() const { return first_use;}
  unsigned get_last_spotted() const { return last_spotted;}

  void parse_iga(const string& s);
};


void print(ostream& out, const iga& i, const bool html= false);


#endif
