/***************************************************************************
                          r2a_iga_list.h  -  description
                             -------------------
    begin                : Sun Jul 11 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_IGA_LIST_H
#define R2A_IGA_LIST_H

#include <list>
#include <iterator>
#include <iostream>
#include "r2a_iga.h"
#include "r2a_handle.h"


using std::list;
using std::ostream;
using std::iterator;


/**
  *@author Harm Anne Schotanus
  */

class iga_list {
private:
  typedef list < handleT <iga> > iga_listT;
  typedef iga_listT::iterator iga_iter;
  typedef iga_listT::const_iterator iga_citer;

  iga_listT i_list;
  bool del;
protected:
  void find_name(
    const string& uic_code,
    const unsigned country,
    const unsigned year,
    iga_list& il
  ) const;
  void find_number(
    const string& uic_code,
    const unsigned year,
    iga_list& il
  ) const;

public:
  void clear();
	iga_list() {}
	~iga_list() throw() {};
  void print (ostream& out, const bool html=false) const;
  void add(const handleT <iga>& m);
  void find(const string& uic_code, const unsigned country, const unsigned year, iga_list& il) const;
  bool empty() { return i_list.empty();}
};


inline void
iga_list::add(const handleT<iga>& m)
{
  i_list.push_back(m);
}


inline void
iga_list::clear()
{
  i_list.clear();
}





#endif
