/*******************************************************************************
    riv2ascii
    Copyright (C) 2003  Harm Schotanus

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*******************************************************************************/

#include <iostream>
#include <string>
#include "riv2ascii.h"
#include "r2a_main.h"
#include "r2a_helper.h"
#include "r2a_html.h"


using std::string;
using std::ostream;


main_class::~main_class() throw()
{
}



void
main_class::find_match_s(
  sub_class_list& sl,
  const string& to_match,
  const char s,
  const unsigned doubled,
  const unsigned country, 					
	const unsigned year,
  const unsigned axles,
  const typeT tp
) const
{
	Assert<ill_value> (doubled <= 10, ill_value::INTERNAL); // catch for infinite loop
  sub_classes->find_match_s(sl, to_match, s, doubled, country, year, axles, tp);
}


void
print (
  ostream& out,
  const main_class& m,
  const bool html
)
{
  put_row_column(out, html);
	out << m.get_letter() << ' ';
	put_column(out, html);
  write_year(out, m.get_min_year(), m.get_max_year());
	put_column(out, html, " ");
  write_axles(out, m.get_min_axles(), m.get_max_axles());
  out << ':';
  put_column(out, html);
	out << ' ' <<  m.get_description() << endl;
}
