/***************************************************************************
                          r2a_main_list.h  -  description
                             -------------------
    begin                : Sun Jun 6 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_MAIN_LIST_H
#define R2A_MAIN_LIST_H

#include <string>
#include <list>
#include <iostream>
#include "riv2ascii.h"
#include "r2a_main.h"
#include "riv_error.h"
#include "r2a_handle.h"


using std::string;
using std::list;
using std::ostream;


class main_class_list {
private :
  typedef list < handleT <main_class> > main_class_listT;
  typedef main_class_listT::iterator main_class_iter;
  typedef main_class_listT::const_iterator main_class_citer;

  main_class_listT m_list;

public:
  main_class_list() throw() {};
  ~main_class_list() throw();
  void clear();
  void print(ostream& out, const bool html=false) const ;
  void find_match_c(
    const string& str,
    const char s,
    const unsigned axles,
    const unsigned year,
    main_class_list& ml
  ) const ;
  void add_sub (
    const string& caps,
    const char letter,
    const unsigned doubled,
	  const unsigned country,
    const unsigned min_year,
    const unsigned max_year,
	  const unsigned min_axles,
    const unsigned max_axles,
    const typeT type,
  	const string& descr,
    const unsigned line
  );
   void add(const handleT <main_class>& m);
   void add(main_class_iter m);
   friend ostream& operator<< (ostream& out, const main_class_list& c) ;
   void write (ostream& out, const char l, const unsigned axles, const unsigned year, const bool html=false);
   const handleT <main_class>& first() const { return *(m_list.begin()); }
   bool empty() const { return m_list.empty();}
};


inline ostream&
operator<< (
  ostream& out,
  const main_class_list& c
)
{
  c.print(out);
  return out;
}


inline void
main_class_list::clear()
{
  m_list.clear();
}


inline void
main_class_list::add(
  main_class_iter mi
)
{
  m_list.push_back(*mi);
}


#endif

