/***************************************************************************
                          r2a_main_type.cpp  -  description
                             -------------------
    begin                : Sun Jun 13 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>
#include <iostream>
#include <algorithm>
#include "riv2ascii.h"
#include "r2a_main_type.h"
#include "riv_error.h"
#include "r2a_helper.h"
#include "r2a_html.h"
#include "r2a_prog_error.h"


using std::iostream;
using std::endl;
using std::max;


main_type::main_type()
{
  lownr = highnr = 0;
  type = Passenger;
}


main_type::~main_type()
{
}


main_type::main_type (
  const unsigned low,
  const unsigned high,
  const car_typeT tp,
  const string& descr
) : description (descr)
{
  if (high != 0 && high < low) throw ill_value (ill_value::CODE, low);
  if (low >= 100 or high >= 100) throw ill_value (ill_value::CODE, max(high, low));
  lownr = low;
  highnr = high;
  type = tp;
}


void
print (
  ostream& out,
  const main_type& m,
  const bool html
)
{
  put_row_column(out, html);
  print_range (out, m.get_lownr(), m.get_highnr(), true);
  put_column(out, html);
  out << ' ' << (m.get_car_type() == main_type::Freight ? "freight" : "passenger") << " car: ";
  put_column(out, html);
  out << m.get_description() << endl;
}
