/***************************************************************************
                          r2a_main_type.h  -  description
                             -------------------
    begin                : Sun Jun 13 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_MAIN_TYPE_H
#define R2A_MAIN_TYPE_H


#include <string>
#include <iostream>
#include "riv2ascii.h"


/**
  *@author Harm Anne Schotanus
  */


using std::string;
using std::ostream;


class main_type {
public:
  typedef enum {
    Passenger,
    Freight
  } car_typeT;

private:
  unsigned lownr, highnr;
  string description;
  car_typeT type;
public: 
	main_type ();
  main_type (const unsigned low, const unsigned high, const car_typeT type, const string& descr);
	~main_type();
  car_typeT get_car_type () const;
  unsigned get_lownr () const;
  unsigned get_highnr () const;
  const string& get_description() const;
  bool match (const unsigned nr, const car_typeT t) const ;
};


void print (ostream& out, const main_type& m, const bool html=false) ;

inline main_type::car_typeT
main_type::get_car_type () const
{
  return type;
}


inline unsigned
main_type::get_lownr () const
{
  return lownr;
}


inline unsigned
main_type::get_highnr () const
{
  return highnr;
}


inline const string&
main_type::get_description() const
{
  return description;
}


inline bool
main_type::match (
  const unsigned nr,
  const car_typeT t
) const
{
  return nr <= highnr && nr >= lownr && t == type;
}


inline ostream&
operator<< (
  ostream& out,
  const main_type& m
)
{
  print(out, m);
  return out;
}


#endif
