/***************************************************************************
                          r2a_main_type_list.cpp  -  description
                             -------------------
    begin                : Sun Jun 13 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <list>
#include <string>
#include <iostream>
#include <algorithm>
#include <iterator>
#include "riv2ascii.h"
#include "r2a_main_type_list.h"
#include "r2a_helper.h"
#include "riv_error.h"
#include "r2a_html.h"
#include "r2a_notfound_error.h"


using std::iostream;
using std::endl;


void
main_type_list::print (
  ostream& out,
  const bool html
) const
{
  put_table p(out, html);
  for_each(m_list.begin(), m_list.end(), printer<main_type>(out,html));
}


class mt_finder {
private:
  unsigned cd;
  main_type::car_typeT t;
public:
  mt_finder(const unsigned c, const main_type::car_typeT ct) : cd(c), t(ct) {}
  bool operator() (const handleT<main_type>& s) {return s->match (cd, t);}
};


handleT <main_type>
main_type_list::find (
  const unsigned cd,
  const main_type::car_typeT t
) const
{
  main_type_citer m = find_if (m_list.begin(), m_list.end(), mt_finder(cd, t));
  if (m == m_list.end()) throw not_found(to_string(cd));
  return *m;
}

