/***************************************************************************
                          r2a_main_type_list.h  -  description
                             -------------------
    begin                : Sun Jun 13 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef R2A_MAIN_TYPE_LIST_H
#define R2A_MAIN_TYPE_LIST_H

#include <string>
#include <list>
#include <iostream>
#include "riv2ascii.h"
#include "r2a_main_type.h"
#include "r2a_handle.h"


/**
  *@author Harm Anne Schotanus
  */

using std::string;
using std::list;
using std::ostream;


class main_type_list {
private:
  typedef list <handleT <main_type> > main_type_listT;
  typedef main_type_listT::iterator main_type_iter;
  typedef main_type_listT::const_iterator main_type_citer;

  main_type_listT m_list;

public:
  void clear();
	main_type_list() {};
	~main_type_list();
  void print (ostream& out, const bool html=false) const;
  void add(const handleT <main_type>& m);
  handleT <main_type> find (const unsigned, const main_type::car_typeT t) const;
};


inline ostream&
operator<< (
  ostream& out,
  const main_type_list& c
)
{
  c.print(out);
  return out;
}


inline
main_type_list::~main_type_list()
{
  clear();
}


inline void
main_type_list::clear()
{
  m_list.clear();
}


inline void
main_type_list::add(
  const handleT <main_type>& t
)
{
  m_list.push_back(t);
}


#endif
