#if 0
/***************************************************************************
                          r2a_main_with_subs.h  -  description
                             -------------------
    begin                : Tue Jul 6 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_MAIN_WITH_SUBS
#define R2A_MAIN_WITH_SUBS


#include <list>
#include <string>
#include <iostream>
#include "riv2ascii.h"
#include "riv_error.h"
#include "r2a_main_with_subs.h"
#include "r2a_sub.h"
#include "r2a_sub_list.h"
//#include "r2a_main.h"
#include "r2a_helper.h"



class main_with_subs : public base_class {
private:
//  main_class mc;
	char letter; // capital
	handleT<sub_class_list> sub_classes;

public:
  main_with_subs() : sub_classes (handleT<sub_class_list> (new sub_class_list)) {}
  ~main_with_subs();
//  main_with_subs(const main_class& m) : mc(m), sub_classes ( handleT<sub_class_list> (new sub_class_list)) { }
  main_with_subs(
    const char l,
    const string& desc,
    const unsigned min_a=0,
		const unsigned max_a=0,
    const unsigned min_y=0,
    const unsigned max_y=0);
 friend ostream& print_sub (
    ostream& out,
    const main_with_subs& s,
    const bool html=false
  );

	void find_match_s(
    sub_class_list& sl,
    const string& to_match,
    const char s,
    const unsigned doubled,
    const unsigned country, 	
		const unsigned year,
    const unsigned axles,
    const typeT type=unknown
  ) const;
  int add (handleT <sub_class> &p);
  void clear();
//  const main_class& get_main_class() const;
  char get_letter() const;
//    const string& get_description() const;
//    unsigned get_max_year() const ;
//  	unsigned get_min_year() const;
//  	unsigned get_max_axles() const;
//	  unsigned get_min_axles() const;
  bool match (
      const char l,
      const unsigned axles=0,
      const unsigned year=0
    ) const;
  friend void print (
    ostream& out,
    const main_with_subs& m,
    const bool html=false
  );

};


inline void
main_with_subs::clear()
{
  //sub_classes.clear();
}

/*
int
add_main(
  const main_with_subs* m
);*/


inline int
main_with_subs::add (handleT <sub_class>& p)
{
  return sub_classes->add(p);
}


inline ostream&
print_sub (
    ostream& out,
    const main_with_subs& mc,
    const bool html
  )
{
  mc.sub_classes->print(out, html);
  return out;
}

/*
inline const string&
main_with_subs::get_description() const
{
  return get_description();
}	


inline unsigned
main_with_subs::get_max_year() const
{
  return get_max_year();
}


inline unsigned
main_with_subs::get_min_year() const
{
  return get_min_year();
}


inline unsigned
main_with_subs::get_max_axles() const
{
  return get_max_axles();
}


inline unsigned
main_with_subs::get_min_axles() const
{
  return get_min_axles();
}

*/
inline bool main_with_subs::match (
    const char l,
    const unsigned axles,
    const unsigned year
  ) const
{
	return ((l == get_letter()) &&
	  between(year, get_min_year(), get_max_year()) &&
    between(axles, get_min_axles(), get_max_axles()));
}

/*
inline void
print (
    ostream& out,
    const main_with_subs& m,
    const bool html
  )
{
  print(out, m.mc, html);

} */

	
inline char
main_with_subs::get_letter() const
{
  return letter;
}


/*
inline const main_class&
main_with_subs::get_main_class() const
{
  return mc;
} */


inline
main_with_subs::main_with_subs(
    const char l,
    const string& desc,
    const unsigned min_a,
		const unsigned max_a,
    const unsigned min_y,
    const unsigned max_y) :
     base_class(min_a, max_a, min_y, max_y, desc),
     sub_classes ( handleT<sub_class_list> (new sub_class_list))
{
  if (!isupper(l)) throw inv_letter(l);
  letter = l;
}

#endif

#endif
