/***************************************************************************
                          r2a_regime_list.cpp  -  description
                             -------------------
    begin                : Sat Jun 12 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>
#include <iostream>
#include <iterator>
#include <list>
#include <algorithm>
#include "r2a_helper.h"
#include "riv2ascii.h"
#include "r2a_regime.h"
#include "r2a_regime_list.h"
#include "riv_error.h"
#include "r2a_html.h"
#include "r2a_notfound_error.h"


using std::iostream;
using std::endl;


handleT <regimeT>
regime_list::find (
  const unsigned reg
) const
{
  regime_citer r = find_if (r_list.begin(), r_list.end(), finder<regimeT>(reg));
  if (r == r_list.end()) throw not_found(to_string (reg));
  return *r;
}


regime_list::~regime_list()
{
}


void
regime_list::print (
  ostream& out,
  const bool html
) const
{
  put_table p(out, html);
  for_each(r_list.begin(), r_list.end(), printer<regimeT>(out, html));
}

