/***************************************************************************
                          r2a_speed_heat.cpp  -  description
                             -------------------
    begin                : Sun Jun 13 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>
#include <iostream>
#include <algorithm>
#include "riv2ascii.h"
#include "r2a_speed_heat.h"
#include "riv_error.h"
#include "r2a_helper.h"
#include "r2a_html.h"
#include "r2a_prog_error.h"


using std::endl;
using std::max;


speed_heat::speed_heat()
{
  lownr = highnr = speed = 0;
}


speed_heat::~speed_heat()
{
}


speed_heat::speed_heat(
  const unsigned low,
  const unsigned high,
  const unsigned spd,
  const string& ht
) : speed (spd), heating (ht)
{
  if (high != 0 && low > high) throw ill_value (ill_value::CODE, low);
  if (low >= 100 or high >= 100) throw ill_value (ill_value::CODE, max (high, low));

  lownr = low;
  highnr = high;
}


void
print (
  ostream& out,
  const speed_heat& s,
  const bool html
)
{
  put_row_column(out, html);
  print_range (out, s.get_lownr(), s.get_highnr(), true);
  put_column(out, html);
  out << " speed: " << s. get_speed() << " heating: " << s.get_heating() << endl;

}

