/***************************************************************************
                          r2a_speed_heat.h  -  description
                             -------------------
    begin                : Sun Jun 13 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_SPEED_HEAT_H
#define R2A_SPEED_HEAT_H


#include <iostream>
#include <string>
#include "riv2ascii.h"


using std::string;
using std::ostream;


/**
  *@author Harm Anne Schotanus
  */

class speed_heat {
private:
  unsigned lownr, highnr;
  unsigned speed;
  string heating;

public:
	speed_heat();
  speed_heat(const unsigned low, const unsigned high, const unsigned speed, const string& heating);
	~speed_heat();
  unsigned get_speed () const ;
  unsigned get_lownr () const ;
  unsigned get_highnr () const ;
  const string& get_heating () const ;
  bool match (const unsigned nr) const ;

};


void print (ostream& out, const speed_heat& s, const bool html=false);

inline unsigned
speed_heat::get_speed () const
{
  return speed;
}


inline unsigned
speed_heat::get_lownr () const
{
  return lownr;
}


inline unsigned
speed_heat::get_highnr () const
{
  return highnr;
}


inline const string&
speed_heat::get_heating () const
{
  return heating;
}


inline bool
speed_heat::match (const unsigned nr) const
{
  return nr <= highnr && nr >= lownr;
}


#endif
