/***************************************************************************
                          r2a_speed_heat_list.h  -  description
                             -------------------
    begin                : Sun Jun 13 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_SPEED_HEAT_LIST_H
#define R2A_SPEED_HEAT_LIST_H

#include <list>
#include <string>
#include <iterator>
#include <iostream>
#include "riv2ascii.h"
#include "r2a_speed_heat.h"
#include "r2a_handle.h"


using std::string;
using std::list;
using std::ostream;
using std::endl;


/**
  *@author Harm Anne Schotanus
  */

class speed_heat_list {
public:
  typedef list <handleT <speed_heat> > speed_heat_listT;
  typedef speed_heat_listT::iterator speed_heat_iter;
  typedef speed_heat_listT::const_iterator speed_heat_citer;
private:
  speed_heat_listT s_list;

public:
  void clear();
	speed_heat_list() {}
	~speed_heat_list() {}
  void add(const handleT <speed_heat>& m) ;
 void print (ostream& out, const bool html=false) const;
  handleT<speed_heat> find(const unsigned cd) const;
};


inline void
speed_heat_list::add(
  const handleT <speed_heat>& m
)
{
  s_list.push_back (m);
}


inline void
speed_heat_list::clear()
{
  s_list.clear();
}


#endif
