/***************************************************************************
                          r2a_sub_list.h  -  description
                             -------------------
    begin                : Sun Jun 6 2004
    copyright            : (C) 2004 by Harm Anne Schotanus
    email                : spearhead@wanadoo.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef R2A_SUB_LIST_H
#define R2A_SUB_LIST_H


#include <string>
#include <list>
#include <iostream>
#include "riv2ascii.h"
#include "base_class.h"
#include "r2a_handle.h"


using std::string;
using std::list;


class sub_class_list {
private:
  typedef list <handleT <sub_class> > sub_class_listT;
  typedef sub_class_listT::iterator sub_class_iter;
  typedef sub_class_listT::const_iterator sub_class_citer;

  sub_class_listT s_list;

public:
  sub_class_list () {}
  ~sub_class_list () {}
  void clear () ;
  void print(ostream& out, const bool html=false) const;
  int add (const handleT <sub_class>& p);
  void find_match_s(
    sub_class_list& sl,
    const string& to_match,
    const char s,
    const unsigned doubled,
    const unsigned country, 					
  	const unsigned year,
    const unsigned axles,
    const typeT tp
  ) const ;
  void write(
    ostream& out,
    const unsigned axles,
    const unsigned year,
    const unsigned cntry,
    const typeT tp,
    const bool html=false
  );
  bool empty() { return s_list.empty();}
};


inline ostream&
operator<< (
  ostream& out,
  const sub_class_list& c
)
{
  c.print(out);
  return out;
}


inline void
sub_class_list::clear()
{
  s_list.clear();
}


#endif

