/*******************************************************************************
	
    riv2ascii
    Copyright (C) 2003  Harm Schotanus

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/

#ifndef RIV2ASCII_H
#define RIV2ASCII_H


// define __NO_STD_STL_STRING_COMPARE__ for old-style string-compare
//#define __NO_STD_STL_STRING_COMPARE__
//#undef __NO_STD_STL_STRING_COMPARE__


#include <string>


#define UIC     0
#define BUFSIZE 4096


using std::string;


typedef enum {
  UIC_UNDEFINED,
  UIC_REGIME,
  UIC_SMALL,
  UIC_CAPITAL,
  UIC_COUNTRY,
  UIC_SPEEDHEAT,
  UIC_MAINTYPE,
  UIC_IGA
} filetypeT;


typedef enum {
  unknown,
  articulated,
  single,
  unit
} typeT;


const char prompt[] = "> ";
const char comment_char = '#';
const unsigned HISTORY_SIZE = 256;
const unsigned LINE_SIZE = 80;


#endif /* RIV2ASCII_H */


